package service

import (
	"f5"
	"main/constant"
	"main/model"
	"main/mt"
	"main/vo"
)

type award struct {
}

func (this *award) init() {
}

func (this *award) unInit() {
}

func (this *award) AddItem(accountId string, itemId int32, itemNum int32, baseVo *vo.BaseVo) {
	nowTime := f5.GetApp().GetRealSeconds()
	itemMeta := mt.Table.Item.GetById(int64(itemId))
	if itemMeta == nil {
		return
	}
	if itemMeta.GetItemType() == constant.ITEM_TYPE_SPEC_DICE {
		user := new(model.User)
		if err, found := user.Find(accountId, nowTime); err == nil && found {
			user.AddSpecDice(itemNum)
			if baseVo != nil {
				baseVo.GetOrCreateSideEffect().User = new(vo.User)
				baseVo.GetOrCreateSideEffect().User.FromModel(user)
				baseVo.GetOrCreateSideEffect().User.HourlyEarnings = Chip.GetHourEarning(user.AccountId)
			}
		}
		return
	}
	bagItem := new(model.Bag)
	if err, found := bagItem.FindByItemId(accountId, itemId); err == nil {
		if found {
			bagItem.AddItemNum(itemNum, int32(nowTime))
		} else {
			bagItem.AccountId = accountId
			bagItem.ItemId = itemId
			bagItem.ItemNum = itemNum
			bagItem.CreateTime = int32(nowTime)
			bagItem.ModifyTime = int32(nowTime)
			bagItem.Create()
		}
		if baseVo != nil {
			baseVo.GetOrCreateAward().AddItem(itemId, itemNum)
		}
	}
}

func (aa *award) HandleAwards(user *model.User, totalaward *vo.Award) (bageffect bool, taskupdate bool) {
	bageffect = false
	for _, awarditem := range totalaward.Items {
		itemcfg := mt.Table.Item.GetById(int64(awarditem.ItemId))
		switch itemcfg.GetItemType() {
		case constant.ITEM_TYPE_SCORE:
			user.AddScore(awarditem.ItemNum)
			taskupdate = Task.UpdateTaskProgress(user.AccountId, constant.ITEM_TYPE_SCORE, awarditem.ItemNum, nil)
		case constant.ITEM_TYPE_DICE:
			user.AddDice(awarditem.ItemNum)
		case constant.ITEM_TYPE_SPEC_DICE:
			user.AddSpecDice(awarditem.ItemNum)
		case constant.ITEM_TYPE_CHIP:
			nowTime := int32(f5.GetApp().GetRealSeconds())
			for i := int32(0); i < awarditem.ItemNum; i++ {
				chip := new(model.Chip)
				chip.AccountId = user.AccountId
				chip.ItemId = awarditem.ItemId
				chip.ItemNum = 1
				chip.ExpireTime = nowTime + itemcfg.GetTime()*60
				chip.CreateTime = nowTime
				chip.ModifyTime = nowTime
				if chip.Create() != nil {
					f5.GetSysLog().Error("internal error, mapgrid chip award fail:%s, %d, %d", user.AccountId, user.CurrGrid, awarditem.ItemId)
				}
			}
		case constant.ITEM_TYPE_SCORE_DOUBLE_CARD:
			fallthrough
		case constant.ITEM_TYPE_SCORE_SMALL_GIFT_PACK:
			fallthrough
		case constant.ITEM_TYPE_SCORE_BIG_GIFT_PACK:
			aa.AddItem(user.AccountId, awarditem.ItemId, awarditem.ItemNum, nil)
			bageffect = true
		}
	}

	return bageffect, taskupdate
}
